routes/admin.php
<?php

use Illuminate\Support\Facades\Route;
use App\Http\Controllers\Admin\LoginAdminController;
use App\Http\Controllers\Admin\AdminController;
use App\Http\Controllers\Admin\CategoryController;
use App\Http\Controllers\Admin\ArticleController;
use App\Http\Controllers\Admin\UserController;
use App\Http\Controllers\Admin\RechargeController;
use App\Http\Controllers\Admin\Select;

// ------------------------------Admin ForgetPassword--------------------------
Route::get('foregtpassword', function () {
return view('Backend.Admin.forget_email');
})->name('foregtpassword');

Route::get('resetpassword', function () {
return view('Backend.Admin.reset');
})->name('resetpassword');


//--------------------------------------- Admin Login-------------------------------
Route::group(['namespace' => 'Auth'], function () {
    Route::get('login', [LoginAdminController::class, 'showLoginForm'])->name('admin_login');
    Route::post('login', [LoginAdminController::class, 'login']);
    Route::post('logout', [LoginAdminController::class, 'logout'])->name('admin_logout');
});


// --------------------------------------Dashbooard View------------------------------
Route::group(['middleware' => 'auth:admin'], function () {
Route::get('/dasboard', function () {
    return view('Backend.Admin.dashboard');
})->name('dasboard');


//--------------------------------------Admin Profile Module---------------------------
Route::get('/profile', [AdminController::class, 'profileview'])->name('profile_view');
Route::post('/profile-update', [AdminController::class, 'profileupdate'])->name('profile_update');
Route::get('change-view', [AdminController::class, 'changePasswordview'])->name('view');
Route::post('change-pass', [AdminController::class, 'changePassword'])->name('change_pass');


//--------------------------------------category--------------------------- 
Route::resource('category',CategoryController::class);


//--------------------------------------Article---------------------------- 
Route::resource('article',ArticleController::class);



//-------------------------------------User display-----------------------
Route::resource('user',UserController::class);


//------------------------------------Recharge display--------------------
Route::resource('recharge',RechargeController::class);
Route::get('recharge-status',[RechargeController::class,'Rechargestatus'])->name('recharge-status');
Route::get('mail-send',[RechargeController::class,'mail'])->name('mail_send');


});

routes/web.php
<?php

use App\Http\Controllers\frontend\ArticleController;
use App\Http\Controllers\frontend\PostController;
use App\Http\Controllers\HomeController;
use App\Http\Controllers\RechagerController;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/


Route::get('/', function () {
    return view('frantend.home');
});

Auth::routes();
Route::get('/post', [HomeController::class, 'index'])->name('home');

Route::group(['middleware' => 'auth:web'], function () {

    //---------------------------------------Post--------------------------------- 
    Route::resource('post', PostController::class);
    Route::post('request-send', [PostController::class,'sendrequest'])->name('sendrequest');




    // ------------------------------------Article Like and coment----------------

    Route::get('like/{id}', [ArticleController::class, 'like'])->name('like');
    Route::get('dislikes/{id}', [ArticleController::class, 'dislikes'])->name('dislikes');
    Route::Post('submit_comment/{id}', [ArticleController::class, 'comment'])->name('submit_comment');
});

app/Models/Article.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Article extends Model
{
    use HasFactory;

    protected $filable = [
        'maincat_id',
        'subcat_id',
        'title',
        'description',
        'like',
        'comment',
        'image',
    ];

    public function maincat()
    {
        return $this->hasOne(ArticleCategory::class, 'id', 'maincat_id');
    }
    public function subcat()
    {
        return $this->hasOne(ArticleSubCategory::class, 'id', 'subcat_id');
    }

    public function like_count()
    {
        return $this->hasMany(Like::class, 'art_id', 'id');
    }
    
    public function comment_count()
    {
        return $this->hasMany(Comment::class, 'art_id', 'id');
    }
 
}

app/Http/Controllers/API/ArticleController.php
<?php

namespace App\Http\Controllers\APi;

use App\Http\Controllers\Controller;
use App\Models\Article;
use App\Models\Comment;
use App\Models\Like;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;

class ArticleController extends Controller
{
    public function showarticle()
    {
        return Article::get();
    }

    public function artilcelike()
    {
        $like = new Like();
        $art_id = Article::get()->first();
        $user_Id = Auth::user()->id;
        $like->user_Id = $user_Id;
        $like->art_id = $art_id->id;
        $like->status = 'Like';
        $like->save();
        return response([
            'User name' => Auth::user()->name,
            'Request Sent' => "thanks For ur like"
        ]);
    }

    public function artilcedislike(Request $request)
    {
        $art_id = Article::get()->first();
        $dislike = Like::where('user_id', Auth::user()->id)->where('art_id', $art_id->id)->first();
        $dislike->forceDelete();
        return response([
            'User name' => Auth::user()->name,
            'Request Sent' => "😏😏😏😏Dislike done"
        ]);
    }

    public function artilcecomment(Request $request,$id)
    {
        $comment = new Comment();
        $art_id = Article::where('id', $id)->first();
        $user_Id = Auth::id();
        $comment->name = Auth::user()->name;
        $comment->user_Id = $user_Id;
        $comment->art_id = $art_id->id;
        $comment->comment = $request['comment'];
        $comment->save();
         return response([
         'User name' => Auth::user()->name,
         'Request Sent' => "😃😃 Thanks for valueable comment"
         ]);
    }
}

app/Http/Controllers/Admin/ArticleController.php
<?php

namespace App\Http\Controllers\Admin;

use App\DataTables\ArticleDataTable;
use App\DataTables\ArticleSubCategoryDataTable;
use App\Http\Controllers\Controller;
use App\Http\Requests\Admin\Article\CreateArtRequest;
use App\Models\Article;
use App\Models\ArticleCategory;
use App\Models\ArticleSubCategory;
use Illuminate\Http\Request;

class ArticleController extends Controller
{
    
    public function index(ArticleDataTable $dataTable)
    {
    return $dataTable->render('Backend.articles.art_table');
    }


    

    public function create()
    {
        $main_cat = ArticleCategory::all();
        $sub_cat = ArticleSubCategory::all();
        return view('Backend.articles.art_create',compact('sub_cat','main_cat'));
    }

    public function store(CreateArtRequest $request)
    {
        $images = uploadFile($request['image'], 'ArticleImage');
        $art_create = new Article;
        $art_create->maincat_id = $request['maincat_id'];
        $art_create->subcat_id = $request['subcat_id'];
        $art_create->title = $request['title'];
        $art_create->description = $request['description'];
        $art_create->image = $images;
        $art_create->save();
        return redirect()->route('admin.article.index');
    }
   
    public function show($id)
    {
        $art = Article::find($id);
        return view('Backend.articles.art_show',compact('art'));
    }

    public function edit($id)
    {
        $art_edit = Article::find($id);
        $maincat = ArticleCategory::all();
        $subcat = ArticleSubCategory::all();
        return view('Backend.articles.art_edit',compact('art_edit','maincat','subcat'));
    }

    public function update(Request $request,$id)
    {
        $edit_art = Article::get()->first();
        if (isset($request->image)) {
        $image = uploadFile($request->image,'ArticleImage');
        } else {
        $image = $edit_art->getRawOriginal('image');
        }
        $edit_art->maincat_id = $request->maincat_id;
        $edit_art->subcat_id = $request->subcat_id;
        $edit_art->title = $request->title;
        $edit_art->description = $request->description;
        $edit_art->image = $image;
        $edit_art->update();
        return redirect()->route('admin.article.index');
    }

    public function destroy(Request $request ,$id)
    {
        $art_delete = Article::find($id);
        $art_delete->delete();
        $request->session()->flash('warning', 'Your Data Deleted successfully ');
        return redirect()->route('admin.article.index');
    }

   
}

app/Http/Controllers/frontend/ArticleController.php
<?php

namespace App\Http\Controllers\frontend;

use App\Http\Controllers\Controller;
use App\Models\Article;
use App\Models\Comment;
use App\Models\Like;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;

class ArticleController extends Controller
{
   public function  like(Request $req, $id)
   {
        $like = new Like();
        $art_id = Article::find($id);
        $user_Id = Auth::id();
        $like->user_Id = $user_Id;
        $like->art_id = $art_id->id;
        $like->status = 'Like';
        $like->save();
        return redirect()->back();
   }

    public function dislikes(Request $request)
    {
        $art_id = Article::find($request['id']);
        $dislike = Like::where('user_id', Auth::user()->id)->where('art_id', $art_id->id)->first();
        $dislike->forceDelete();
        return redirect()->back();
    }
    public function comment(Request $request, $id)
    {
        $comment = new Comment();
        $art_id = Article::where('id', $id)->first();
        $user_Id = Auth::id();
        $comment->name = Auth::user()->name;
        $comment->user_Id = $user_Id;
        $comment->art_id = $art_id->id;
        $comment->comment = $request['comment'];
        $comment->save();
        return redirect()->back();
    }
}

resources/views/Backend/articles/art_create.blade.php
@extends('Backend.Admin.layouts.master')
@section('content')

<link href="https://cdn.jsdelivr.net/npm/select2@4.1.0-rc.0/dist/css/select2.min.css" rel="stylesheet" />

<div class="col-md-6 grid-margin stretch-card">
    <div class="card">
        <div class="card-body">
            <br>
            <br>
            <br>
            <h4 style="font-size:200%;" class="card-title">Add Article</h4>
            <hr style="height:2px;border-width:0;color:gray;background-color:gray">
            <form class="forms-sample myform" method="POST" action="{{route('admin.article.store')}}" enctype="multipart/form-data">
                @csrf
                <div class="form-group row">
                    <label for="password" class="col-sm-3 col-form-label">Category</label>
                    <div class="col-md-6">
                        <select class="form-control category_select @error('maincat_id') is-invalid @enderror" id="maincat_id" name="maincat_id">
                            <option value="">Select Main Category</option>
                            @foreach ($main_cat as $main_cat)
                            <option value="{{ $main_cat->id }}">{{$main_cat->name}}</option>
                            @endforeach
                        </select>
                        @error('maincat_id')
                        <span class="invalid-feedback" role="alert">
                            <strong>{{ $message }}</strong>
                        </span>
                        @enderror
                    </div>
                </div>
                <div class="form-group row">
                    <label for="subcat_id" class="col-sm-3 col-form-label">Sub Category</label>
                    <div class="col-md-6">
                        <select class="form-control subcat_id @error('subcat_id') is-invalid @enderror" id="subcat_id" name="subcat_id">
                            <option class="dropdown-item" value="0">select one subcategory</option>
                        </select>
                        @error('subcat_id')
                        <span class="invalid-feedback" role="alert">
                            <strong>{{ $message }}</strong>
                        </span>
                        @enderror
                    </div>
                </div>
                <div class="form-group row">
                    <label for="exampleInputUsername2" class="col-sm-3 col-form-label">Title</label>
                    <div class="col-sm-9">
                        <input type="text" class="form-control @error('title') is-invalid @enderror" id="title" name="title" value="{{ old('title') }}" placeholder="title">
                        @error('title')
                        <span class="invalid-feedback" role="alert">
                            <strong>{{ $message }}</strong>
                        </span>
                        @enderror
                    </div>
                </div>
                <div class="form-group row">
                    <label for="exampleInputEmail2" class="col-sm-3 col-form-label">Description</label>
                    <div class="col-sm-9">
                        <textarea class="ckeditor form-control @error('description') is-invalid @enderror" name="description" id="description" value="{{ old('description') }}">{{ old('description') }}</textarea>
                        @error('description')
                        <span class="invalid-feedback" role="alert">
                            <strong>{{ $message }}</strong>
                        </span>
                        @enderror
                    </div>
                </div>
                <div class="form-group row">
                    <label for="exampleInputPassword2" class="col-sm-3 col-form-label ">image</label>
                    <div class="col-sm-9">
                        <input type="file" id="image" name="image" value="{{ old('image') }}" class="form-control @error('image') is-invalid @enderror">
                        @error('image')
                        <span class="invalid-feedback" role="alert">
                            <strong>{{ $message }}</strong>
                        </span>
                        @enderror
                    </div>
                </div>
                <button type="submit" class="btn btn-primary mr-2">Submit</button>
                <button class="btn btn-light">Cancel</button>
            </form>
        </div>
    </div>
</div>



@endsection
@push('scripts')
<script src="https://code.jquery.com/jquery-3.5.0.js" integrity="sha256-r/AaFHrszJtwpe+tHyNi/XCfMxYpbsRg2Uqn0x3s2zc=" crossorigin="anonymous"></script>
<script src="https://cdn.datatables.net/1.10.16/js/jquery.dataTables.min.js"></script>
<script src="https://cdn.datatables.net/1.10.19/js/dataTables.bootstrap4.min.js"></script>
<script src="https://cdn.ckeditor.com/4.16.2/standard/ckeditor.js"></script>
<script src="{{ asset('Admin/asset/js/select2.js') }}"></script>
<script>
    $(document).ready(function() {
        $('.ckeditor').ckeditor();
    });

    $('#maincat_id').on('change', function() {
        var maincat_id = this.value;
        $.ajax({
            url: "{{ route('admin.category.store') }}"
            , type: "post"
            , data: {
                maincat_id: maincat_id
                , _token: '{{ csrf_token() }}'
            }
            , dataType: 'json'
            , success: function(result) {
                console.log(result);
                $('#subcat_id').html('<option class="dropdown-item" value="">Select Sub Category</option>');
                $.each(result, function(key, value) {
                    $("#subcat_id").append('<option class="dropdown-item" value="' + value.id + '">' + value.sub_name + '</option>');

                });
            }
        });
    })

    $(document).ready(function() {
        $('.category_select').select2();
    });

</script>
@endpush

resources/views/Backend/articles/art_edit.blade.php
@extends('Backend.Admin.layouts.master')
@section('content')
<div class="content-wrapper">
    <div class="container-fluid">
        <div class="row">
            <div class="col-md-9">
                <div class="contact-form">
                    <div class="form-group">
                        <br>
                        <br>
                        <br>
                        <h4 style="font-size:200%;" class="card-title">Edit Articlel</h4>
                    </div>
                    <form class="forms-sample" method="post" action="{{ route('admin.article.update',$art_edit->id) }}"
                        enctype="multipart/form-data">
                        @csrf
                        @method('put')
                        <input type="hidden" name="id" value="{{$art_edit->id}}">
                        <div class="form-group">
                            <label for="password" class="col-sm-3 col-form-label">Category</label>
                            <select class="form-control @error('maincat_id') is-invalid @enderror" id="maincat_id"
                                name="maincat_id">
                                @foreach ($maincat as $category)
                                <option value="{{ $category->id }}" {{ $art_edit->maincat_id == $category->id ?
                                    'selected' : ''}}>{{ $category->name}}</option>
                                @endforeach
                            </select>
                        </div>
                        <div class="form-group">
                            <label for="password" class="col-sm-3 col-form-label"> Sub Category</label>
                            <select class="form-control @error('subcat_id') is-invalid @enderror" id="subcat_id"
                                name="subcat_id">
                                @foreach ($subcat as $category)
                                <option value="{{ $category->id }}" {{ $art_edit->subcat_id == $category->id ?
                                    'selected' : ''}}>{{ $category->sub_name}}</option>
                                @endforeach
                            </select>
                        </div>
                        <div class="form-group">
                            <label for="name">Title Name</label>
                            <input type="text" name="title" class="form-control @error('title') is-invalid @enderror"
                                value="{{$art_edit->title}}">
                            @error('title')
                            <span class="invalid-feedback" role="alert">
                                <strong>{{ $message }}</strong>
                            </span>
                            @enderror
                        </div>
                        <div class="form-group">
                            <label for="description">Description </label>
                            <textarea
                                class="ckeditor form-control form-control @error('description') is-invalid @enderror"
                                name="description" id="description">{!!$art_edit->description!!}</textarea>
                        </div>
                        <div class="form-group">
                            <input type="file" id="image" name="image" value="{{$art_edit->image}}"
                                class="form-control @error('image') is-invalid @enderror">
                            <img src="{{asset('storage/ArticleImage/'.$art_edit->image)}}" alt="image" width="50"
                                height="50" />
                        </div>
                        <br>
                        <input type="submit" class="btn btn-primary"></input>
                        <input type="button" class="btn btn-dabger"><a
                            href="{{route('admin.article.index')}}">Cancel</a></input>
                    </form>
                </div>
            </div>
        </div>
    </div>
</div>
@endsection

resources/views/Backend/articles/art_show.blade.php
@extends('Backend.Admin.layouts.master')
@section('content')
<body>
    <div class="content-wrapper">
        <div class="container-fluid">
            <div class="card">
                <br>
                <br>
                <br>
                <div class="card-header">
                    <h3>Article details</h3>
                </div>
                <div class="card-body">
                    <div class="row">
                        <div class="form-group col-md-6">
                            <label for="main_cat">Category Name</label>
                            <input type="text" name="main_cat" id="main_cat" value="{{$art->maincat->name}}" class="form-control"  readonly>
                        </div>
                        <div class="form-group col-md-6">
                            <label for="sub_cat">Sub Category Name</label>
                            <input type="text" name="sub_cat" id="sub_cat" value="{{$art->subcat->sub_name}}" class="form-control"  readonly>
                        </div>
                    </div>
                    <div class="row">
                        <div class="form-group col-md-6">
                            <label for="title">Title</label>
                            <input type="text" name="title" id="title" value="{{ $art->title }}" class="form-control"  readonly>
                        </div>
                        <div class="form-group col-md-6">
                            <label for="descrition">Description</label>
                            <textarea class="ckeditor form-control form-control @error('description') is-invalid @enderror" name="description" id="description" readonly>{!!$art->description!!}</textarea>
                        </div>
                    </div>
                    <div class="row">
                        <div class="form-group col-md-6">
                            <label for="restaurant">Like of this title</label>
                            <input type="text" name="restaurant" id="restaurant" value="{{ $art->like }}" class="form-control"  readonly>
                        </div>
                        <div class="form-group col-md-6">
                            <label for="restaurant">Commnet of this title</label>
                            <input type="text" name="restaurant" id="restaurant" value="{{ $art->comment }}" class="form-control" readonly>
                        </div>
                    </div>
                    <center>
                        <div class="form-group">
                            <label for="restaurant">Article Image</label><br>
                            <img src="{{asset('storage/ArticleImage/'.$art['image'])}}" class=" img-thumbnail float-center" width="100px" height="100px" alt="">
                        </div>
                        <a href="{{ route('admin.article.index') }}"> <button class="btn btn-success">| Go to Home</button></a>
                    </center>
                </div>
            </div>
        </div>
    </div>
</body>

@endsection

resources/views/Backend/articles/art_table.blade.php
@extends('Backend.Admin.layouts.master')
@section('content')
<link href="https://cdn.jsdelivr.net/npm/bootstrap@5.1.0/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-KyZXEAg3QhqLMpG8r+8fhAXLRk2vvoC2f3B09zVXn8CA5QIVfZOJ3BCsw2P0p/We" crossorigin="anonymous">
<link rel="stylesheet" type="text/css" href="https://cdn.datatables.net/1.11.0/css/dataTables.bootstrap4.min.css">
<div class="main-panel">
    <div class="content-wrapper">
        <br>
        <br>
        <a href="{{ route('admin.article.create') }}" class="btn btn-success float-right">Add Article</a>&nbsp;

        <div class="page-header">
            <h3 style="font-size:150%;" class="page-title">Tables </h3>
        </div>
        <div class="row">
            <div class="col-lg-12 grid-margin stretch-card">
                <div class="card">
                    <div class="card-body">
                        <h4 style="font-size:150%;" class="card-title">Article List </h4>
                        <section style="padding-top: 60px;">
                            <div class="container">
                                <div class="row">
                                    <div class="col-md-12">
                                        {!! $dataTable->table(['class' => 'table table-bordered dt-responsive nowrap']) !!}
                                    </div>
                                </div>
                            </div>
                        </section>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>
@endsection
@push('scripts')
<script src="https://code.jquery.com/jquery-3.5.0.js" integrity="sha256-r/AaFHrszJtwpe+tHyNi/XCfMxYpbsRg2Uqn0x3s2zc=" crossorigin="anonymous"></script>
<script src="https://cdn.datatables.net/1.10.16/js/jquery.dataTables.min.js"></script>
<script src="https://cdn.datatables.net/1.10.19/js/dataTables.bootstrap4.min.js"></script>
{!! $dataTable->scripts() !!}
@endpush